globals [safe numShot mShot bShot perbM perB distanceFromShot endExp closestCitizen closestShooter row seat dontIgnoreRule]  ;; keep track of how much grass there is
;; Sheep and wolves are both breeds of turtle.
breed [gunMen a-gunMan]  ;; sheep is its own plural, so we use "a-sheep" as the singular.
breed [citizens citizen]
breed [guards a-guard]
turtles-own [hit ;; have you been hit
  acc ;; how accurate are you
  fireRate ;; how quickly can you fire
  magazine ;; how large is your magazine
  downTime ;; how quickly can your reload and shoot accurately 
  id ;; how likely are you to identify the right person (if wrong will fire at that person for 1 turn before readjusting) (if hit innocent person chance of being assumed a second gun men)
  patchMovement ;; how fast you can run
  fightOrFight ;; indicates wether to fight or run
  carryingGun;; indicates wether you are carrying a gun
  distanceFromLine ;; distance from line
  distanceFromGuardShot ;; distance from guard Shot
  perturb
  timeSpentReloading 
  movementSpeed
  accAdj
  shotAt 
  dontHide
  shooter
  leaving
  constant
  bulletSec
  numberShotsFired ;counter for the number of shots fired
  ]       
;; turns will always fire if being fired upon (assuming they have choosen to fight)



to setup
  clear-all
  
   ask patches [if pycor <= 40.8623 and pycor >= 38.3859 and pxcor >= 4 and pxcor <= 46 [set pcolor orange]]
 ask patches [if pycor <= 37.9095 and pycor >= 35.4331 and pxcor >= 4 and pxcor <= 46 [set pcolor orange]]
 ask patches [if pycor <= 34.9567 and pycor >= 32.4804 and pxcor >= 4 and pxcor <= 46 [set pcolor orange]]
 ask patches [if pycor <= 31.004 and pycor >= 29.5276 and pxcor >= 4 and pxcor <= 46 [set pcolor orange]]
 ask patches [if pycor <= 28.0512 and pycor >= 26.5758 and pxcor >= 4 and pxcor <= 46 [set pcolor orange]]
 
 ask patches [if pycor <= 22.1457 and pycor >= 20.6693 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 19.1929 and pycor >= 17.7166 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 16.2402 and pycor >= 14.7638 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 13.2874 and pycor >= 11.811 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 10.3347 and pycor >= 8.85828 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 7.3819 and pycor >= 5.90552 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 4.42914 and pycor >= 2.95276 and pxcor > 7.2 and pxcor < 42.8 [set pcolor orange]]
 ask patches [if pycor <= 7.3819 and pycor >= 5.90552 and ( pxcor >= 46 or pxcor <= 4 )[set pcolor orange]]
 ask patches [if pycor <= 4.42914 and pycor >= 2.95276 and (pxcor >= 46 or pxcor <= 4 )[set pcolor orange]]
 ask patches [if (pxcor = 4 or pxcor = 46) and pycor > 7.3819 and pycor <= 22.1457  [set pcolor brown]]
 ask patches [if pycor <= 1.47638 [set pcolor orange]]
 ask patches [ if pycor > 7.3819 and pycor < 13.2874 and (pxcor > 46 or pxcor < 4) [set pcolor green]]
  set endExp False
  set numShot 0 
  set safe 0
  
  set row 39.6241
  set seat 5.6
  set dontIgnoreRule true 
    set-default-shape gunMen "person"
  create-gunMen 1  ;; create the wolves, then initialize their variables
  [
    set numberShotsFired 0
    set color red
    set size 1.5  ;; easier to see
    set acc rifleAccuracy
    set timeSpentReloading 0
    set magazine rifleCapacity
    set downTime rifleReloadTime  ;; 
    set hit 0
    set shotAt 0
    setxy 2 48
  ]
  set-default-shape citizens "person"
  create-citizens 300;; create the sheep, then initialize their variables
  [
    set leaving false
    set dontHide true
    set constant random-float 4
    if random 99 < 10
    [
      set dontHide false
    ]
 ;   set timeSpentReloading 0
    set color blue
   set size 1  ;; easier to see
  
    while [movementSpeed < 1]
    [
      set movementSpeed random-normal 7.0 2 ;; movement speed of people fleeing 6.0 feet a second
    ]
    ;populates the theater seats with people
      setxy seat row 
      set seat (seat + 1.6)
      if seat > 44.5 and dontIgnoreRule
      [
        set row row - 2.9
        set seat 5.6
      ]
      if row <= 26 and row > 22
      [
        set row 21.4075
      ]
      if row <= 21.4075 and row > 1.47638 and seat < 6
      [
        set seat 8.8
      ]
      if row <= 21.4075 and row > 1.47638 and seat > 42 
      [
         set seat 8.8
        set row row - 2.92
      ]
      if row < 1.47638 and seat = 8.8
      [
        set seat 1.6
        set dontIgnoreRule false
      ]
  ]

  
end


to go
  ifelse safe + numShot + count citizens with [dontHide = false]  < 300 and count gunMen > 0
  [
    set endExp False
    ask citizens 
    [
      set distanceFromLine 1000
    ]
    
    ask citizens [react]
    ask gunMen
    [
      gunMenaction
    ]
   tick
  ]
  [
    set endExp True
    
  ]

  
end


 
to react
      if color != red and dontHide = true 
      [
         ;front section of movie theather
         if ycor > 25 and xcor < 25
         [
           set heading 270
         ]
         if ycor > 25 and xcor >= 25
         [
           set heading 90
         ]
         
   
         ; middle section back of movie theater
         if ycor <= 26 and xcor < 25 and xcor > 7.2
         [
           set heading 270
         ]
         if ycor <= 26 and xcor >= 25 and xcor < 42.8
         [
           set heading 90
         ]
         
         ;back row
         if ycor <= 7.3 and xcor < 25 and xcor <= 4
         [
           set heading 90
         ]
         if ycor <= 7.3 and xcor >= 25 and xcor >= 46
         [
           set heading 270
         ]
         
         ;going down back aisle
         
         if ycor <= 22.1542  and xcor > 4 and xcor < 7.2
         [
           set heading 0
         ]
         if ycor <= 22.1542  and xcor > 42.8 and xcor < 46
         [
           set heading 0
         ]
         
         ;front aisle
         if ycor > 22.1457 and (xcor < (4 - constant) or xcor > (46 + constant))
         [
           set heading  180 
         ]
         
         ;between back of theather and front of theater
         if ycor > 22.1457 and ycor < 26.5758  and xcor < 25 and xcor > 4
         [
           set heading 270
         ]
         
         if ycor > 22.1457 and ycor < 26.5758  and xcor >= 25 and xcor < 46
         [
           set heading 90
         ]
         
         
         ;exit 
         if ycor < 23 and ycor > 7.3 and (xcor < 4 or xcor > 46)
         [
          set heading 180
          set leaving true
         ]
         
         let tempMovement 0   
         let peopleInFront citizens in-radius movementSpeed
         let personINFront  0
         
          foreach sort-by [[distance  myself] of ?1 < [distance  myself] of ?2] peopleInFront
          [
            ask ?[
              let xOffset xcor - [xcor] of myself ;; find how many off in the x direction the potential targert and gun man are
              let yOffset ycor - [ycor] of myself ;; find how many off in the y direction the potential target and gun man are
                                                  ;;if statement makes sure only people in front of gun men eligble to be shot
              if personINFront = 0
              [
                if (yOffset > 0 and ([Heading] of myself > 90 or [Heading] of myself > 270)) or (yOffset <= 0 and ([Heading] of myself <= 90 and [Heading] of myself <= 270))
                [
                  if (xOffset > 0 and [Heading] of myself < 180) or (xOffset <= 0 and [Heading] of myself >= 180)
                  [
                    if [distance  myself] of ?1 < movementSpeed
                    [
                      
                        set tempMovement (movementSpeed * .1)
                        set personINFront 1
                       
                    ]
                  ]
                ]
              ]
         
            ]
         ]
         ifelse personINFront = 0 
         [
           fd movementSpeed
         ]
         [
           fd tempMovement
         ]
      if ycor < 13.2874 and leaving = true
      [
        set safe (safe + 1)
        die
      ]
     ]
         
    
end

to gunMenaction
  ;;can use to augment firing rate (default 1 round second)
  ifelse random-float 1 < 0.11111
  [
    set bulletSec 1
  ]
  [
    set bulletSec 1
  ]
  ifelse magazine > 0
  [
    let observed  0
    let numbCivilians count citizens
    let listAgents min-n-of numbCivilians citizens[ distance  myself]
    foreach sort-by [[distance  myself] of ?1 < [distance  myself] of ?2] listAgents
      [ if [dontHide] of ? = true and observed = 0 and [color] of ? != red
    
       [let xgrid [xcor] of ? ;; locates xposition
       let ygrid [ycor] of ?;; locates yposition
       facexy xgrid ygrid 
       set observed 1
       ]
      ]
    let numberShots 0 
    let prey one-of citizens-here                    ;; grab a random person
    
      ;; changes heading so that east is 0 and goes counter clockwise
    let headingTheta (360 - heading )  
    if headingTheta = 360 [set headingTheta 0]
    ifelse headingTheta > 269 [set headingTheta (headingTheta - 270)] [ set headingTheta (headingTheta + 90)]
    if headingTheta = 90 or headingTheta = 270  or headingTheta = 0 or headingTheta = 180[set headingTheta (headingTheta + .0001)]
    
    
    
    while [numberShots < bulletSec and magazine > 0]
    [
      set numberShotsFired (numberShotsFired + 1);total number of shots fired since sumlation began
      set numberShots ( numberShots + 1);number of shots fired during this time step
      set magazine (magazine - 1)
      ;; how far off one person might pull a shot
      set perturb random-normal 0 (acc)
      let perturbedHeading 0
      ;; adjust the heading so we get skewed shot
      
      ifelse perturb > 0
      [
        ifelse headingTheta + perturb > 360
        [
          set perturbedHeading (headingTheta + perturb - 360)
        ]
        [
          set perturbedHeading (headingTheta + perturb)
        ]
      ]
      [
        ifelse headingTheta + perturb < 0
        [
          set perturbedHeading (360 + (headingTheta + perturb) )
        ]
        [
          set perturbedHeading (headingTheta + perturb)
        ]
      ]
      
      ;;gives you equation of the line for the heading you fired at
      let m tan(perturbedHeading)
      let b (ycor - m * xcor)
      
      let pslope (1 / m * -1)
      ask citizens [
        
        let bP (ycor - pslope * xcor) ;; find shortest line from citzen to firing line
        let xPoint  (bP - b) / (m -  pslope) ;; find x intercept point on firing line
        let yPoint (xPoint * pslope + bP) ;; find y intercept point on firing line
        set distanceFromLine sqrt( ((xPoint - xcor) ^ 2) + ((yPoint - ycor) ^ 2)) ;; found distance from firing line
        if distanceFromLine > 1 [ set distanceFromLine 1000]
      ]
       set numbCivilians count citizens
       set listAgents min-n-of numbCivilians citizens[ distanceFromLine]
      let killed 0
      foreach sort-by [[distance  myself] of ?1 < [distance  myself] of ?2] listAgents
      [
        
        if killed = 0 and  [distance  myself] of ? < 1000 and [distanceFromLine] of ? < 0.7 and [color] of ? != red
        [
          
          ask ?[
            let xOffset xcor - [xcor] of myself ;; find how many off in the x direction the potential targert and gun man are
            let yOffset ycor - [ycor] of myself ;; find how many off in the y direction the potential target and gun man are
            ;;if statement makes sure only people in front of gun men eligble to be shot
            if (xOffset > 0 and ([perturbedHeading] of myself < 90 or [perturbedHeading] of myself > 270)) or (xOffset <= 0 and ([perturbedHeading] of myself >= 90 and [perturbedHeading] of myself <= 270))
            [
              if (yOffset > 0 and [perturbedHeading] of myself < 180) or (yOffset <= 0 and [perturbedHeading] of myself >= 180)
              [
                set killed 1 ;; makes sure 1 bullet only kills one person
                set numShot numShot + 1 ;; increases the kill count
                set color red
              ]
            ]
          ]
        ]
      ]
      
    ]
    
  ]
  [
    
    set timeSpentReloading (timeSpentReloading + 1)
    if timeSpentReloading > downTime
    [
      ifelse numberShotsFired < rifleAmmo
      [
      set magazine rifleCapacity
      ]
      [
        set magazine handGunCapacity
        set downTime handGunReloadTime 
        set acc handGunAccuracy
      ]
      set timeSpentReloading 0
      
    ]
    
    
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
693
50
1366
744
-1
-1
13.0
1
10
1
1
1
0
0
0
1
0
50
0
50
0
0
1
ticks

BUTTON
16
54
79
87
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

BUTTON
110
53
173
90
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

TEXTBOX
1188
190
1338
208
NIL
11
0.0
1

MONITOR
459
60
516
105
NIL
safe
17
1
11

MONITOR
545
59
609
104
NIL
numShot
17
1
11

TEXTBOX
66
139
216
157
Gun men controls
11
0.0
1

SLIDER
32
177
204
210
rifleCapacity
rifleCapacity
0
100
50
1
1
NIL
HORIZONTAL

SLIDER
32
235
204
268
rifleAmmo
rifleAmmo
0
100
45
1
1
NIL
HORIZONTAL

SLIDER
32
284
204
317
rifleReloadTime
rifleReloadTime
1
5
2
1
1
NIL
HORIZONTAL

SLIDER
30
339
202
372
rifleAccuracy
rifleAccuracy
0
5
2
0.1
1
NIL
HORIZONTAL

SLIDER
233
175
405
208
handGunCapacity
handGunCapacity
1
30
15
1
1
NIL
HORIZONTAL

SLIDER
235
240
407
273
handGunAmmo
handGunAmmo
1
60
60
1
1
NIL
HORIZONTAL

SLIDER
232
287
404
320
handGunReloadTime
handGunReloadTime
1
5
2
1
1
NIL
HORIZONTAL

SLIDER
231
342
403
375
handGunAccuracy
handGunAccuracy
0
5
3
.1
1
NIL
HORIZONTAL

@#$#@#$#@
WHAT IS IT?
-----------
On July 20th, James Holmes committed a mass shooting in a midnight showing of The Dark Knight Rises. Mr. Holmes was armed with a 12-gague Remington 870 Express Tactical Shotgun, Smith & Wesson M&P 15 semi-automatic rifle, and a Glock 22 40-caliber handgun. It is important to note that all the aforementioned firearms violated Senator Dianne Feinstein assault weapon ban. After releasing tear gas into the theater, James Holmes fired approximately 110 rounds, striking 58 people (CBC News 2012, Fahrenthold 2012, Parker 2012). The Aurora Colorado shooting was used as a test case to validate this
framework for modeling mass shootings.

HOW IT WORKS
------------
The simulation is considered complete when all civilians have either escaped or been shot. 
	Running speed  feet/second the agent can run
	?  the standard deviation a gunman or security guard aims off center
	Capacity  number of rounds the magazine of the agent can hold
	Ammo - maximum amount of ammo for that weapon
	
	Escape Distance is leaving the movie theater via the exit. 
The simulation environment consists of a two-dimensional Cartesian world. When it is either the gunmans turn to act, they aim directly for the center of their target. The bullet they fire is perturbed from this intended trajectory. This error represents both the guns and the shooters accuracy. A smaller perturbation is indicative of a more accurate gun and shooter. The perturbation is a normally distributed random variable. The baseline standard deviation (?) of the random variable is calculated from the maximum effective distance of the gun. The maximum effective distance of a gun is considered the distance at which an average trained shooter can hit a human torso, assumed 1.4 feet in diameter, 50% of the time. Assuming a normal distribution, it becomes possible to determine the standard deviation or baseline measure of the accuracy for each weapon. Take for example the AR-15, which has an effective range of 1804.46 feet (Dockery 2007).
 ?=tan^(-1)?(radius human torso)/(effective range)?
	Using the equation above, the AR-15s ?=0.022 degrees. In other words, 50% of the time the AR-15 will fire a bullet within 0.022 degrees of the intended aiming line. The mean of the random normal distribution is assumed to be 0. To determine the standard deviation, the equation ?=  ?/0.67 is used (Bertsekas 2002).
	In the case of the AR-15, the standard deviation is 0.033. Any additional deviation is caused by the shooter; therefore to represent a less accurate shooter the standard deviation can be increased. We now have the information necessary to plot the trajectory of a bullet fired. The shooter aims at the center of the target. For the gunman, this is the closest civilian the bullet leaves at a trajectory that is altered by random normal distribution; for the AR-15 this is N(0,0.033 + human error).  The bullet travels on this adjusted trajectory, and the first person that is less than 0.7 feet (assumed radius of the torso) off of the trajectory and within the range of the gun is considered shot. The bullet is assumed to travel instantaneously and does not penetrate through a person or wall.

HOW TO USE IT
-------------
The user of the simulation can adjust the parameters of the weapons. An interesting thing to do is to examine what factors affect the number of people shot. For example,
is the amount of people shot affected more by magazine capcity or reload time.

RELATED MODELS
--------------
The base model for this simulation can be found:
Hayes, Roy Lee, Hayes, Reginald Lee (2013, August 26). "Mass Shooting Simulation" (Version 1). CoMSES Com-putational Model Library. Retrieved from: http://www.openabm.org/model/3920/version/1

CREDITS AND REFERENCES
----------------------
CBC News. (July 20, 2012) "Batman premiere gunman looked like 'assassin ready for war'". Retrieved August 25, 2013. http://www.cbc.ca/news/world/story/2012/07/20/denver-shooting-movie-premiere.html

Fahrenthold, D. (July 22, 2012) Colorado shooting spree could have been worse; shooters gun jammed, official says. The Washington Post. Retrieved August 25, 2013. http://www.washingtonpost.com/national/explosives-removed-from-james-holmess-apartment-and-destroyed-officials-say/2012/07/22/gJQAL9XN2W_story.html

Parker, M. (July 23, 2012) "Rifle failure that stopped yet more batman carnage." Daily Express. Retrieved August 25, 2013.http://www.express.co.uk/posts/view/334642/Rifle-failure-that-stopped-yet-more-Batman-carnage
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
0
Rectangle -7500403 true true 151 225 180 285
Rectangle -7500403 true true 47 225 75 285
Rectangle -7500403 true true 15 75 210 225
Circle -7500403 true true 135 75 150
Circle -16777216 true false 165 76 116

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.1.3
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="openGroundRampage" repetitions="30" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <exitCondition>endExp = True</exitCondition>
    <metric>safe</metric>
    <enumeratedValueSet variable="speed">
      <value value="2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="numberPeople">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="accuracy">
      <value value="3"/>
    </enumeratedValueSet>
    <steppedValueSet variable="bulletSec" first="1" step="1" last="5"/>
    <enumeratedValueSet variable="reloadTime">
      <value value="2"/>
    </enumeratedValueSet>
    <steppedValueSet variable="capacity" first="10" step="5" last="30"/>
    <steppedValueSet variable="Range" first="10" step="10" last="100"/>
    <enumeratedValueSet variable="EscapeRanage">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="aggression">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="gunCarriers">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="identification">
      <value value="50"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="openFieldSecurityGuard" repetitions="30" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <exitCondition>endExp = True</exitCondition>
    <metric>numShot</metric>
    <steppedValueSet variable="numSecGuards" first="0" step="1" last="3"/>
    <steppedValueSet variable="accuracy" first="0.2" step="0.2" last="2"/>
    <enumeratedValueSet variable="reloadTime">
      <value value="2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="secRange">
      <value value="500"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="EscapeRanage">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="secReloadTime">
      <value value="2"/>
    </enumeratedValueSet>
    <steppedValueSet variable="capacity" first="10" step="5" last="30"/>
    <enumeratedValueSet variable="Range">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="numberPeople">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="secBulletSec">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="secCapacity">
      <value value="15"/>
    </enumeratedValueSet>
    <steppedValueSet variable="bulletSec" first="1" step="1" last="3"/>
    <enumeratedValueSet variable="secAccuracy">
      <value value="1"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment" repetitions="100" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="1000"/>
    <metric>numShot</metric>
    <enumeratedValueSet variable="rifleAccuracy">
      <value value="2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="rifleCapacity">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="handGunCapacity">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="handGunAmmo">
      <value value="60"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="rifleAmmo">
      <value value="45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="rifleReloadTime">
      <value value="2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="handGunAccuracy">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="handGunReloadTime">
      <value value="2"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 1.0 0.0
0.0 1 1.0 0.0
0.2 0 1.0 0.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
